; main.asm
extern  fopen
extern  fscanf
extern  fclose
extern  printf
extern  stdout

extern  InRectangle
extern  InTriangle
extern  InShape
extern  InContainer

extern  OutRectangle
extern  OutTriangle
extern  OutShape
extern  OutContainer

extern  PerimeterRectangle
extern  PerimeterTriangle
extern  PerimeterShape
extern  PerimeterContainer

global  RECTANGLE
global  TRIANGLE

section .data
    RECTANGLE   dd  1
    TRIANGLE    dd  2

    rectFile        dq  "tests/rectFile.txt",0    ; имя тестового файла с прямоугольником
    trianFile       dq  "tests/trianFile.txt",0   ; имя тестового файла с треугольником
    shapeRectFile   dq  "tests/shapeRectFile.txt",0    ; имя тестового файла с прямоугольником
    shapeTrianFile  dq  "tests/shapeTrianFile.txt",0   ; имя тестового файла с треугольником
    shapeContFile  dq   "tests/contFile.txt",0   ; имя тестового файла с треугольником
    toRead          db  "r"

    rectOutFmt      db "It is Rectangle: x = %d, y = %d",10,0
    trianOutFmt     db "It is Triangle: a = %d, b = %d, c = %d",10,0
    tagOutFmt       db "Tag is: %d. ",0

section .bss
    FILE    resq    1       ; Указатель на FILE
    rShape  resd    1       ; Признак прямоугольника = RECTANGLE
    rect    resd    2       ; x, y
    tShape  resd    1       ; Признак треугольника = TRIANGLE
    trian   resd    3       ; a, b, c
    cont    resb    160     ; буфер, используемый для заполнения фигурами (до 10 фигур)
    len     resd    1       ; число заполненных элементов в контейнере
section .text
    global main
;----------------------------------------------
main:
    push    rbp
    mov     rbp,rsp

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Открытие файла для чтения прямоугольника
    mov     rdi, rectFile       ; имя открываемого файла
    lea     rsi, toRead         ; открыть для чтения
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fopen
    mov     [FILE], rax         ; сохранение указателя на файл

    ; Ввод параметров прямоугольника
    mov     rdi, rect
    mov     rsi, [FILE]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    InRectangle

    ; Закрытие файла с прямоугольником
    mov     rdi, [FILE]         ; передача указателя на закрываемый файл
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fclose

    ; Вывод параметров прямоугольника
    mov     rdi, rect
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutRectangle

    ; Тестовый вывод информации о прямоугольнике в консоль
;     mov     rdi, rectOutFmt     ; Формат - 1-й аргумент
;     mov     rax, rect           ; адрес прямоугольника
;     mov     esi, [rax]          ; x
;     mov     edx, [rax+4]        ; y
;     mov     rax, 0              ; нет чисел с плавающей точкой
;     call    printf

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Открытие файла для чтения треугольника
    mov     rdi, trianFile       ; имя открываемого файла
    lea     rsi, toRead         ; открыть для чтения
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fopen
    mov     [FILE], rax         ; сохранение указателя на файл

    ; Ввод параметров треугольника
    mov     rdi, trian
    mov     rsi, [FILE]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    InTriangle

    ; Закрытие файла с треугольником
    mov     rdi, [FILE]         ; передача указателя на закрываемый файл
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fclose

    ; Вывод параметров треугольника
    mov     rdi, trian
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutTriangle

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Открытие файла для чтения фигуры-прямоугольника
    mov     rdi, shapeRectFile  ; имя открываемого файла
    lea     rsi, toRead         ; открыть для чтения
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fopen
    mov     [FILE], rax         ; сохранение указателя на файл

    ; Ввод параметров фигуры-прямоугольника
    mov     rdi, rShape
    mov     rsi, [FILE]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    InShape

    ; Закрытие файла с фигурой-прямоугольником
    mov     rdi, [FILE]         ; передача указателя на закрываемый файл
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fclose

    ; Вывод параметров фигуры-прямоугольника
    mov     rdi, rShape
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutShape

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Открытие файла для чтения фигуры-треугольника
    mov     rdi, shapeTrianFile  ; имя открываемого файла
    lea     rsi, toRead         ; открыть для чтения
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fopen
    mov     [FILE], rax         ; сохранение указателя на файл

    ; Ввод параметров фигуры-треугольника
    mov     rdi, tShape
    mov     rsi, [FILE]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    InShape

    ; Закрытие файла с фигурой-треугольником
    mov     rdi, [FILE]         ; передача указателя на закрываемый файл
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fclose

    ; Вывод параметров фигуры-треугольника
    mov     rdi, tShape
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutShape

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Открытие файла для чтения фигур в контейнер
    mov     rdi, shapeContFile  ; имя открываемого файла
    lea     rsi, toRead         ; открыть для чтения
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fopen
    mov     [FILE], rax         ; сохранение указателя на файл

    ; Ввод фигур в контейнер
    mov     rdi, cont           ; адрес контейнера
    mov     rsi, len            ; адрес для установки числа элементов
    mov     rdx, [FILE]         ; указатель на файл
    xor     rax, rax
    call    InContainer         ; ввод данных в контейнер

    ;;;;; Ввод параметров фигуры
;     mov     rdi, cont
;     mov     rsi, [FILE]
;     mov     rax, 0              ; нет чисел с плавающей точкой
;     call    InShape

    ; Закрытие файла с фигурами для контейнера
    mov     rdi, [FILE]         ; передача указателя на закрываемый файл
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fclose

    ;;;;; Вывод параметров фигуры
;     mov     rdi, cont
;     mov     rsi, [stdout]
;     mov     rax, 0              ; нет чисел с плавающей точкой
;     call    OutShape

    ; Вывод результата ввода в контейнер

    mov     rdi, cont
    mov     rsi, [len]
    mov     rdx, [stdout]
    call    OutContainer

    pop     rbp
    mov     rax,60
    mov     rdi,0

syscall
